### Steve Dodson
### August 24, 2000
### Parses a NCSA style log.  Reads a filter file (filter.dat)
### to see if any IPs should be skipped over when reporting.
### Creates an HTML file (NCSA_log.html) with the results.

### Tested on NS browsers 3.x, 4.x, 6.0 PR and IE browsers 4.x, 5.x
### Have not tried Unix or Max platforms...could break.

print "\n\nNOTICE: This program parses a NCSA formatted log\n where all logging options have been enabled\n";
print "Enter any IP addresses or domain names you want filtered into \nthe file \"Filter.dat\"\n\n";
print "Enter the log file to parse.\nInclude the path if necessary.\nPress 'Q' to quit.\n";
print "Filename: ";
$path = <STDIN>;
chomp ($path);
if ($path eq "q" | $path eq "Q")
{
  exit;
}
### Check to see if the file exists
elsif ( (-e $path) )  
{
open (INFILE, "$path");
open (OUTFILE, ">NCSA_log.html");
open (FILTER, "filter.dat");
while (<FILTER>)
{
   chomp($_);
   @filterArray = split(/\+/, $_);
}
$mainCounter = 0;
OUTER: while (<INFILE>)
{
   @quoteSplit = split (/\"/, $_);
   $quoteCounter = 0;
    foreach ( @quoteSplit )
   {
      chomp($_);
      if ($quoteCounter == 0)
      {
         splitIP();
      }
      elsif ($quoteCounter == 1)
      {
         splitRequest ();
      }
      elsif ($quoteCounter == 2)
      {
         splitFileCode ();
      }
      elsif ($quoteCounter == 3)
      {
         $finalRefer[$mainCounter] = $quoteSplit[3];
      }
      elsif ($quoteCounter == 5)
      {
         splitBrowser();
      }
      else
      {
         # Do nothing
      }

   $quoteCounter ++;
   }
   $mainCounter ++;
}
#printOS();
}

### Print HTML header
$td = "<TD><B>";
$td2 = "</B></TD>";
print OUTFILE "<HTML>\n<BODY>\n<!-- Log Parser by Steve Dodson: http://dodson.morpheus.net -->\n";
print OUTFILE "<TABLE BORDER=1 ALIGN=Center>\n<TR BGCOLOR=Silver ALIGN=Center>$td IP $td2 \n";
print OUTFILE "$td Time $td2 \n $td File Hit $td2 \n $td Error Code $td2 \n $td Bytes Transferred $td2 \n $td Referer $td2 \n";
print OUTFILE "$td Browser $td2 \n $td OS $td2 \n </TR> \n";

$HTMLCounter = 0;
foreach(@finalIP)
{
   print OUTFILE "<TR>\n";
   print OUTFILE "<TD>$finalIP[$HTMLCounter]</TD>\n";
   print OUTFILE "<TD>$finalTime[$HTMLCounter]</TD>\n";
   print OUTFILE "<TD>$finalFile[$HTMLCounter]</TD>\n";
   print OUTFILE "<TD>$finalFileCode[$HTMLCounter]</TD>\n";
   print OUTFILE "<TD>$finalFileSize[$HTMLCounter]</TD>\n";
   print OUTFILE "<TD>$finalRefer[$HTMLCounter]</TD>\n";
   print OUTFILE "<TD>$finalBrowser[$HTMLCounter]</TD>\n";
   print OUTFILE "<TD>$finalOS[$HTMLCounter]</TD>\n";
   print OUTFILE "</TR>\n";
   $HTMLCounter++;
}

print OUTFILE "</TABLE>";
print OUTFILE "\n<BR><B>Number of hits:</B> $mainCounter<BR>";
print OUTFILE "\n<B>Filtered IPs or Domains: </B><BR>";
$filterPrintCntr = 0;

foreach ( @filterArray )
{
   $counter = $filterPrintCntr + 1;
   print OUTFILE "$counter.) $filterArray[$filterPrintCntr]<BR>";
   $filterPrintCntr++;
}
print OUTFILE "\n</BODY></HTML>";

sub splitIP
{
   s#[\[\]]*##g;
   @IPSpaceSplit = split (/ /, $_);
   ### --------------------------------------------------------------------------------------
   ### finalIP=Remote User's IP   finalID=User's ID   finalName=Username  
   ### finalTime=Time Accessed   finalGMT=GMT Offset
   ### --------------------------------------------------------------------------------------

   $filterCounter = 0;
   foreach (@filterArray)
   {
      if ($IPSpaceSplit[0] eq $filterArray[$filterCounter])
      {
         next OUTER;
      }
      $filterCounter ++;
   }

   $finalIP[$mainCounter] = $IPSpaceSplit[0];   
   # $finalID[$mainCounter] = $IPSpaceSplit[1];
   # $finalName[$mainCounter] = $IPSpaceSplit[2];
   $finalTime[$mainCounter] = $IPSpaceSplit[3];
   # $finalGMT[$mainCounter] = $IPSpaceSplit[4];
}

sub splitRequest
{
   ### ---------------------------------------------------------------------
   ### finalMethod=GET or PUT   finalFile=File Accessed  
   ### finalProtocol=HTTP version
   ### ---------------------------------------------------------------------
   @requestSplit = split(/ /, $_);
   #$finalMethod[$mainCounter] = $requestSplit[0];
   $finalFile[$mainCounter] = $requestSplit[1];
    #$finalProtocol[$mainCounter] = $requestSplit[2];
}

sub splitFileCode
{
   ### ---------------------------------------------------------------------------------------------------
   ### finalFileCode=Error Code - see below
   ### [200-No error , 300-Redirection, 400-Client-side error, 500-Server-side error]
   ### finalFileSize=Bytes Sent
   ### ---------------------------------------------------------------------------------------------------
   @fileCodeSplit = split (/ /, $_);
   $finalFileCode[$mainCounter] = $fileCodeSplit[1];
   $finalFileSize[$mainCounter] = $fileCodeSplit[2];
}

sub printOS 
{
   foreach ( @finalBrowser )
   {
      print "\n$_";
   }
}

sub splitBrowser 
{
         s#\)##g;
         ### Check to see if the browser type was even resolved
         if ($_ =~ /Moz/)
         {
            ### Check for Netscape 4.x browsers - evident by the [ ] 
            if ($_ =~ /[\[\]]+/)
            {
               @NSParenSplit = split(/\(/, $_);
               $finalBrowser[$mainCounter] = $NSParenSplit[0];
               foreach ( @NSParenSplit )
               {
                  @NSSemiSplit = split(/\;/, $_);
                  $finalOS[$mainCounter] = $NSSemiSplit[0];
               }
            }
            ### Check for NS (and possibly IE??) 3.x browsers
            elsif ($_ =~ /Mozilla\/3/)
            {
               @NS3Split = split(/\(/, $_);
               $finalBrowser[$mainCounter] = $NS3Split[0];
               $finalOS[$mainCounter] = "Unknown";
            }
            ### Check for NS 6 browsers
            elsif ($_ =~ /Gecko/ || $_ =~ /Netscape6/)
            {
               @NS6Split = split(/\(/, $_);
               $finalBrowser[$mainCounter] = $NS6Split[0];
               foreach ( @NS6Split )
               {
                  @NS6SemiSplit = split(/\;/, $_);
                  $finalOS[$mainCounter] = $NS6SemiSplit[2];
               }
            }
            ### Check for IE Browser
            elsif ($_ =~ /MSIE/)
            {
              @IESemiSplit = split(/\;/, $_);
               $finalBrowser[$mainCounter] = $IESemiSplit[1];
               $finalOS[$mainCounter] = $IESemiSplit[2];
            }
         }
         else
         {
            $finalBrowser[$mainCounter] = "Unknown";
            $finalOS[$mainCounter] = "Unknown";
         }
}
close INFILE;
close OUTFILE;
close FILTER;